# Copyright (C) 2009 Ferdinand Majerech
# This file is part of IMGCrush
# For conditions of distribution and use, see copyright notice in __init__.pyfrom util import *

from tempimage import *
from imagesettings import *
from referencefile import *

class GIFProcessor:
    """Handles GIF file generation and it's settings.
    """
    
    def __init__(self,tempdir):
        """Constructor.

        Data members:
        TempDir   : Directory to use to store generated temporary files.
        Interlace : Generate interlaced GIF images ?.
        """ 
        self.TempDir = tempdir 
        self.Interlace = False
  
    def set_interlace(self):
        """Turn generation of interlaced GIF images on.
        """
        self.Interlace = True                 
  
    def process_gif(self, reffile, filenoext):
        """Generate GIF files according to settings and return a list of them.
        """
        print "\nprocessing gif"
        outfilelist = []
        outfilelist.append(TempImage(self.TempDir + filenoext + ".gif", "gif",
                           GIFSettings(False), reffile))
        if self.Interlace:
            outfilelist.append(TempImage(self.TempDir + filenoext + "_i_.gif",
                               "gif", GIFSettings(True), reffile))
        return outfilelist
