
def command_line_help():
    """Prints command line help, invoked by --help command or wrong input.
    """
    print "IMGCrush 0.21"
    print "Copyright (C) 2009 Ferdinand Majerech"
    print "Usage: imgcrush [OPTION...] [FILE/DIR...]"
    print "Optimizes images for size"
    print "\n  --help           display this help and exit"
    print " -o --outdir         directory to save optimized images to  default:./optimized/"
    print " -t --tempdir        directory to save temp files to  default:/dev/shm/imgcrush/"
    print "\nFormat options:"
    print " -j --jpg            use JPG format                                default:false"
    print " -p --png            use PNG format                                default:false"
    print " -g --gif            use GIF format                                default:false"
    print "\nJPG specific options:"
    print "    --jpgqual    val minimum quality used (0-100)                  default:50"
    print "    --jpgstep    val step to increment quality by, i.e." 
    print "                     quality 50 with step 10 means quality"
    print "                     50,60...100 will be used (1-100)              default:10"
    print "    --jpginterlace   use interlacing (progressive files)"
    print "                     this usually worsens size, so it's unlikely"
    print "                     that the optimization output will be "
    print "                     interlaced"
    print "    --jpgoptimize    use jpg compression optimization -this"
    print "                     usually improves size"
    print "    --jpgsampfactors"
    print "                 val subsampling factors to use for jpg"
    print "                     possible values:"
    print "                     standard -use most common factors:"
    print "                               1x1,2x1 and 2x2"
    print "                     all -use all available factors."
    print "                     fac1,fac2,fac3 -comma separated list of"
    print "                        factors, e.g:"
    print "                        --jpgsampfactors 1x1,1x2,1x4"
    print "                     available factors:"
    print "                     1x1,1x2,1x4,2x1,2x2,2x4,4x1,4x2"
    print "\nPNG specific options:"
    print "    --pnglev     val minimum compression level used   (0-9)        default:7"
    print "    --pngfilt    val string of filters used, i.e. to use"
    print "                     filters 0, 1 and 3 write --pngfilt 013" 
    print "                     possible values:"
    print "                     0 -no filter -best for indexed images"
    print "                     1 -sub"
    print "                     2 -up"
    print "                     3 -average"
    print "                     4 -paeth -good for truecolor images"
    print "                     5 -adaptive when level>5 and indexed"
    print "                     6 -adaptive -best for truecolor               default:06"
    print "    --pngpal     val minimum bit depth to use for indexed"
    print "                     images -if 0, don't use indexed images"
    print "                     possible values: 1,2,4,8                      default:0"
    print "    --pnggray    val minimum bit depth to use for grayscale"
    print "                     images -if 0, don't use grayscale "
    print "                     possible values: 2,3,4,8                      default:0"
    print "    --pngbitmap      use bitmaps"
    print "    --pnginterlace   use interlacing -allows images to be"
    print "                     loaded progressively, usually worsens"
    print "                     size, so it's unlikely that the optimization"
    print "                     output will be interlaced"
    print "\nGIF specific options:"
    print "    --gifinterlace   use interlaced files (progressive) -usually"
    print "                     increases file size so it's unlikely that"
    print "                     optimization output will be interlaced."
    print "\nOptimization related options:"
    print " -m --mode       val mode of optimization,possible values:"
    print "                     q -optimize to quality, i.e. output "
    print "                       will be the smallest file with at"
    print "                       least the given quality"
    print "                     s -optimize to size,i.e. output'll be"
    print "                        best image with at most given size"
    print " -Q --minquality val only applies in q mode: minimum quality"
    print "                     the output can have set in %, e.g."
    print "                     --minquality 100.0% -100% means lossless"
    print "                     quality can also be given subjectively in "
    print "                     range from 0 to 100 without the % sign, e.g."
    print "                     --minquality 99.2 ,in this case it's much"
    print "                     closer to jpg quality.                        default:100%"
    print " -S --maxsize    val only applies in s mode: maximum size the"
    print "                     output can have set in kiB,MiB,GiB,bytes,"
    print "                     % or average bits per pixel."
    print "                     e.g. --maxsize 50.1kiB ,or --maxsize 51303"
    print "                     when in %, e.g. --maxsize 50.5%, the size is" 
    print "                     coomputed as percentage f size of input file," 
    print "                     when % is prefixed by r,e.g. --maxsize 50.5r%" 
    print "                     size of computed as percentage of size of "
    print "                     reference file, a png file generated during"
    print "                     optimization. When using bits "
    print "                     per pixel,e.g. --maxsize 2.4bpp"
    print "                     ,the maximum filesize of the image will be "
    print "                     image area * given value in bits, i.e. a"
    print "                     1024x1024 image with --maxsize 2bpp will"
    print "                     take up at most 2Mb or 256kiB .                default:50%"
    print "\nResizing related options:"
    print "                     Note that by default, resizing preserves"
    print "                     aspect ratio, so width and height are"
    print "                     maximum bounds of the resized image. This can"
    print "                     be changed by --fill and --stretch options."
    print " -w --width      val width of output images in px or %, e.g.:"   
    print "                     -w 20 or -w 20%. 0 means no resize             default:0"
    print " -h --height     val height of output images in px or %, e.g.:"
    print "                     -h 20 or -h 20%. 0 means no resize             default:0"
    print " -f --fill           if resized image doesn't fit given width"
    print "                     and height (has a different aspect ratio),"
    print "                     fill rest of given width/height by "
    print "                     background color with the image centered."
    print " -s --stretch        if resized image doesn't fit given width"
    print "                     and height (has a different aspect ratio),"
    print "                     stretch the image to fill given width/height."
    print " -c --bgcolor    val if --fill is used, this is background color"
    print "                     to use. val is rgb, e.g. -c rgb(128,128,128)"
